#ifndef __PSGLGRAPHICS_H__
#define __PSGLGRAPHICS_H__

#include "IGraphics.h"

#include <PSGL/psgl.h>
#include <PSGL/psglu.h>
#include <cell/dbgfont.h>

class PSGLGraphics : IGraphics<GLfloat, GLint>
{
public:
	PSGLGraphics();
	~PSGLGraphics();

	virtual void Init();
	virtual void Deinit();

	virtual void InitDbgFont();
	virtual void DeinitDbgFont();

	virtual GLfloat GetDeviceAspectRatio();
	virtual GLint GetResolutionWidth();
	virtual GLint GetResolutionHeight();

private:
	PSGLdevice* psgl_device;
	PSGLcontext* psgl_context;
	GLuint gl_width;
	GLuint gl_height;

	CellDbgFontConsoleId dbg_id;
};

#endif
