/*
 * emulator.h
 *
 *  Created on: Oct 11, 2010
 *      Author: halsafar
 *      Edited: Squarepusher2 (Oct 15, 2010)
 */

#ifndef EMULATOR_H_
#define EMULATOR_H_

#define AUDIO_INPUT_RATE (48000)
#define AUDIO_BUFFER_SAMPLES (4096)

enum Emulator_Modes
{
	MODE_MENU,
	MODE_EMULATION,
	MODE_EXIT
};

enum Emulator_ControllerModes
{
	NO_JOYSTICKS,
	TWO_JOYSTICKS,
	MULTITAP,
	MOUSE,
	SUPERSCOPE,
};

void Emulator_SetControllerMode(Emulator_ControllerModes);
Emulator_ControllerModes Emulator_GetControllerMode(void);
void Emulator_RequestLoadROM(char* rom, bool forceReload);
int Emulator_LoadSettings();
int Emulator_SaveSettings();
bool Emulator_IsROMLoaded();
void Emulator_SwitchMode(Emulator_Modes);
void Emulator_Shutdown();
char * Emulator_GetROM();
void Emulator_StopROMRunning();
void Emulator_StartROMRunning();
void Emulator_SetDebugMessage(const char * value);
void Emulator_SaveSRAM();
unsigned int Emulator_CurrentSaveStateSlot();
void Emulator_IncrementCurrentSaveStateSlot();
void Emulator_DecrementCurrentSaveStateSlot();
void Emulator_SetCurrentSaveStateSlot(int set_current_save_state_slot);
void Emulator_ToggleSound();

bool Emulator_IsInitialized();
bool Emulator_ROMRunning();

#endif /* EMULATOR_H_ */
