#ifndef __EMULATOR_AUDIO_H
#define __EMULATOR_AUDIO_H

#include "../old/cellaudioport.h"

inline bool Audio_Init(uint64_t samplerate, uint64_t buffersize)
{
   return cellAudioPortInit(samplerate, buffersize);
}

inline void Audio_Write(const int16_t* buffer, uint64_t samples)
{
   cellAudioPortWrite(buffer, samples);
}

inline uint64_t Audio_WriteAvail()
{
   return cellAudioPortWriteAvail();
}

inline void Audio_Exit()
{
   cellAudioPortExit();
}

inline void Audio_ChangeResamplingFrequency(int newsamplefreq)
{
	Audio_Exit();
	Audio_Init(newsamplefreq,AUDIO_BUFFER_SAMPLES);
}


#endif
