/*
 * emulator_implementation.h
 *
 *  Created on: Oct 15, 2010
 *      Author: Squarepusher2
 */
#ifndef EMULATOR_IMPLEMENTATION_H_
#define EMULATOR_IMPLEMENTATION_H_

#include "emulator.h"
#include "../cellframework/input/cellInput.h"

// SNES buttons
#define BTN_A 1
#define BTN_B 2
#define BTN_X 3
#define BTN_Y 4
#define BTN_SELECT 5
#define BTN_START 6
#define BTN_L 7
#define BTN_R 8
#define BTN_LEFT 9
#define BTN_RIGHT 10
#define BTN_UP 11
#define BTN_DOWN 12
#define BTN_QUICKSAVE 13
#define BTN_QUICKLOAD 14
#define BTN_INCREMENTSAVE 15
#define BTN_DECREMENTSAVE 16

//for mouse
#define MOUSE1_LEFTBUTTON 15
#define MOUSE1_RIGHTBUTTON 16

#define PAD_1 1
#define PAD_2 2
#define PAD_3 3
#define PAD_4 4
#define PAD_5 5

#define MAKE_BUTTON(pad, btn) (((pad)<<4)|(btn))

bool Emulator_Implementation_InitSettings();
bool Emulator_Implementation_InitSystem(Emulator_ControllerModes controller_setting);
void Emulator_Implementation_Inputloop();
void Emulator_Implementation_Pause();
void Emulator_Implementation_Unpause();
void Emulator_Implementation_SaveSRAM();
bool Emulator_Implementation_SaveSettings();

#endif /* EMULATOR_H_ */
